package units {
	import com.greensock.motionPaths.LinePath2D;
	import com.greensock.plugins.BezierPlugin;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	
	import starling.display.Sprite;
	
	
	public class BezierCurve {
		
		private var _curve:Array = [];
		private var _point1:Point = new Point();
		private var _point2:Point = new Point();
		private var _control:Point = new Point();	
		private var _line:Sprite = new Sprite();
		private var _sprite:Sprite = new Sprite();
		
		private var _update:Boolean = false;
		private var _curvePoints:int = 30;
		private var _animate:Boolean = false;
		
		private var linePath:LinePath2D;
		private var angle:Number;
		private var a:Number = 0.01;
		private var progress:Number = 0;
		
		
		public function BezierCurve () {
			
//			drawPoint(_point1);
//			drawPoint(_point2);
//			drawPoint(_control);
//			drawPoint(_sprite, 0xFF9900);
//			
//			addChild(_line);
			
			_point1.x = 50;
			_point1.y = 50;
			
			_point2.x = 350;
			_point2.y = 250;
			
			_control.x = 200;
			_control.y = 350;
			
//			addChild(_point1);
//			addChild(_point2);
//			addChild(_control);
//			addChild(_sprite);
			
			drawCurve();
			
			linePath = new LinePath2D();
			
//			addEventListener(Event.ENTER_FRAME, onLoop, false, 0, true);
//			_sprite.addEventListener(Event.ENTER_FRAME, spriteLoop, false, 0, true);
		}
		
		
		private function drawCurve ():void {
			//grabPoints();
			
//			_line.graphics.clear();
//			_line.graphics.lineStyle(1, 0xFFFFFF);
//			_line.graphics.moveTo(_point1.x, _point1.y);
//			_line.graphics.curveTo(_control.x, _control.y, _point2.x, _point2.y);
//			_line.graphics.beginFill(0xFFFFFF);
//			for (var i:int = 0; i < _curve.length; i++) {
//				_line.graphics.drawCircle(_curve[i].x, _curve[i].y, 4);
//			}
			
		}
		
		
		public function bezPoints(_pointArray:Array):Object
		{
			var dots = new Object();
			dots.x = new Array();
			dots.y = new Array();
			
			for(var i:int = 0; i < _pointArray.length; i++)
			{
				dots.x.push(_pointArray[i].x);
				dots.y.push(_pointArray[i].y);
			}
			
			return dots;
		}
		
		
		public function grabPoints (staticPoints:Array):Array 
		{
			var dots:Object = BezierPlugin.parseBeziers(bezPoints(staticPoints), false);
//			trace(dots.toString());
			
			_curve.length = 0;
			for (var j in dots.x)
			{
				_point1.x = dots.x[j][0];
				_point1.y = dots.y[j][0];
				_control.x = dots.x[j][1];
				_control.y = dots.y[j][1];
				_point2.x = dots.x[j][2];
				_point2.y = dots.y[j][2];
				var t:Number = 0;
				var t1:Number, t1s:Number, ts:Number, tt12:Number, cx:Number, cy:Number;
				
				while (t <= 1) {
					//b = ((1-t)*(1-t)) * p0 + 2*(1-t)*t*p1 + (t*t)*p2 where t ranges from 0 to 1.
					t1 = 1 - t;
					t1s = t1 * t1;
					ts = t * t;
					tt12 = 2 * t * t1;
					cx = t1s * _point1.x + tt12 * _control.x + ts * _point2.x;
					cy = t1s * _point1.y + tt12 * _control.y + ts * _point2.y;
					_curve.push(new Point(cx, cy));
					t += 1/_curvePoints;
				}
			}
			
//			var last:int = _curve.length-1;
//			var prev:int = _curve.length-2;
//			angle = Math.atan2(_curve[last].y - _curve[prev].y, _curve[last].x - _curve[prev].x);
			
			
			return _curve;
		}
		
		
		
//		override protected function onPointDown (event:MouseEvent):void {
//			var s:Sprite = event.target as Sprite;
//			stage.addEventListener(MouseEvent.MOUSE_UP, onPointUp, false, 0, true);
//			s.startDrag(true);
//			_update = true;
//			_animate = false;
//		}
//		
//		private function onPointUp (event:MouseEvent):void {
//			stage.removeEventListener(MouseEvent.MOUSE_UP, onPointUp);
//			stopDrag();
//			_update = false;
//		}
		
		//update curve
		private function onLoop (event:Event):void {
			if (_update) {
				drawCurve();
			} else {
				//move sprite!!!!
				if (!_animate) {
					linePath.points = _curve;
					progress = 0;
					a = 0.01;
					
					linePath.snap(_sprite);
					_animate = true;
				}
			}
		}
		
		//move sprite on the created curve
		private function spriteLoop (event:Event = null):void {
			if (_animate) {
				progress += a;
				if (progress <= 1) {
					linePath.renderObjectAt(_sprite, progress);
					a += 0.005;
				} else {
					
					//grab final speed and angle (you may use initial speed of contact for exit speed)
					_sprite.x += linePath.totalLength*a*Math.cos(angle);
					_sprite.y += linePath.totalLength*a*Math.sin(angle);
					
				}
				
			}
		}
	}
}